pure subroutine update_z(F, z, error)
  use blocks
  implicit none
  real*8, intent(in)    :: F(1:N)
  real*8, intent(inout) :: z(1:N)
  real*8, intent(out)   :: error

  integer*4             :: i

  z(1) = rz
  z(2) = ru + z(1) - F(1)

  !$$$  do i=3,N-1
  do i=3,N
     z(i) = two*z(i-1) - z(i-2) - F(i-1)
  end do
  !$$$  z(N) = ru + z(N-1) + F(N)

  error = ru + z(N-1) - z(N) + F(N)
      
  return
end subroutine update_z
